import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sn


def get_confusion_matrix(labels_predicted, labels_true, classes):
    confusion_matrix = []

    labels_predicted = np.uint8(labels_predicted)
    labels_true = np.uint8(labels_true)

    labels_predicted = labels_predicted.flatten()
    labels_true = labels_true.flatten()
    
    print(labels_true.shape)
    print(labels_predicted.shape)
    for predicted_class in classes:
        row = []
      
        for true_class in classes:
            # All occurences of current true_class in labels_true:
            true_indices = np.where(labels_true == np.uint8(true_class))[0]
          
            
            # All occurences of current predicted_class in labels_predicted:
            predicted_indices = np.where(labels_predicted == np.uint8(predicted_class))[0]
           
            # We want to find the number of elements where these two matches:
            num_occurences = len( np.intersect1d(true_indices, predicted_indices) )
            row.append(num_occurences)

        confusion_matrix.append(row)

    return np.array(confusion_matrix)


def plot_confusion_matrix(confusion_matrix, name):
    class_numbers = ['1' ,'2', '3']
    df_cm = pd.DataFrame(confusion_matrix, index = [i for i in class_numbers],
                  columns = [i for i in class_numbers])
    fig = plt.figure(figsize = (10,7))

    fig.suptitle(name, fontsize=16)

    sn.heatmap(df_cm, annot=True)