from operator import mod
from select import select
from statistics import mode

from this import d
import time
from scipy import rand
import torch
import scipy.io
import matplotlib.pyplot as plt
import numpy as np
from torch import batch_norm, double, nn
from torch.utils.data import TensorDataset
from torch_geometric.data import Data
from torch.nn import BatchNorm1d
import torch.nn.functional as F
from torch_geometric.loader import DataLoader, DenseDataLoader
from torch_geometric.nn import GCNConv, ChebConv, GraphNorm, MessageNorm, TAGConv, GINConv ,GINEConv, ARMAConv, SGConv, APPNP, EdgePooling
from torch_geometric.data import InMemoryDataset, download_url
from tqdm import tqdm
import random
from sklearn.decomposition import FactorAnalysis
from sklearn.decomposition import PCA

import torchvision

from train import *

def make_conv_layer(inputs, outputs):
    return GCNConv(inputs, outputs)

class DGC(torch.nn.Module):
    def __init__(self):
        super().__init__()
        


        self.linear1 = nn.Linear(100, 80)
        self.linear1_2 = nn.Linear(40,100)
        self.linear2 = nn.Linear(80, 50)
        self.linear3 = nn.Linear(50, 25)
        self.batch_norm3_1 = BatchNorm(25, eps=1e-5, momentum=0.9)
        self.linear3_2 = nn.Linear(25, 50)
        self.batch_norm3_2 = BatchNorm(50, eps=1e-5, momentum=0.9)
        self.linear4 = nn.Linear(25, 23)
        self.linear5 = nn.Linear(23, 17)

        self.conv1 = make_conv_layer(100, 100)
        self.batch_norm1 = BatchNorm(100, eps=1e-5, momentum=0.9)
        self.conv2 = make_conv_layer(100, 50)
        self.conv2_2 = make_conv_layer(50, 100)
        self.batch_norm2 = BatchNorm(50, eps=1e-5, momentum=0.9)
        self.conv3 = make_conv_layer(100, 50)
        self.conv3_2 = make_conv_layer(50, 100)
        self.batch_norm3 = BatchNorm(50, eps=1e-5, momentum=0.9)
        self.conv4 = make_conv_layer(80, 60)
        
        self.msg_norm1 = MessageNorm()

        
        
        self.batch_norm3 = BatchNorm(50, eps=1e-5, momentum=0.9)
        self.batch_norm4 = BatchNorm(100, eps=1e-5, momentum=0.9)
        self.batch_norm6 = BatchNorm(40, eps=1e-5, momentum=0.9)
        self.batch_norm5 = BatchNorm(50, eps=1e-5, momentum=0.9)
    
    def forward(self, data):
        x, edge_index = data.x, data.edge_index
        
        x = self.conv1(x, edge_index)
        x = self.batch_norm1(x)
        msg = x
        
        
        #x = F.dropout(x, training=self.training)

        x = self.conv2(x, edge_index)
        x = self.batch_norm2(x)
        x = F.relu(x)
        x = self.conv2_2(x, edge_index)
        x = self.batch_norm1(x)

        x += msg
        x = F.relu(x)
        
        x = self.conv3(x, edge_index)
        x = self.batch_norm3(x)
        x = F.relu(x)
        x = self.conv3_2(x, edge_index)
        x = self.batch_norm1(x)

        x += msg
        #x = self.conv4(x, edge_index)
        #x = self.msg_norm1(x, msg)
        #x = self.batch_norm4(x)
        #x = F.relu(x)
        ###########################################

        ###########################################
        msg = x
        ###
        x = self.linear1(x)
        x = self.batch_norm6(x)
        x = F.relu(x)
        #x = self.linear1_2(x)
        #x = self.batch_norm4(x)
        ####
       # x += msg
       # x = F.relu(x)

        x = self.linear2(x)
        x = self.batch_norm5(x)
        x = F.relu(x)

        #msg = x
        ####
        x = self.linear3(x)
        x = self.batch_norm3_1(x)
        x = F.relu(x)
       # x = self.linear3_2(x)
       # x = self.batch_norm3_2(x)
        ###

       # x += msg
       # x = F.relu(x)

        x = self.linear4(x)
        x = F.relu(x)

        x = self.linear5(x)

        
        return F.log_softmax(x, dim=1)


class GCN(torch.nn.Module):
    def __init__(self):
        super().__init__()
        """super(GCN, self).__init__()"""

        self.inpu_size = 100
        self.num_layers = 1
        

        self.rnn = nn.RNN(self.inpu_size, self.hidden_size, self.num_layers, batch_first=True)
        self.input_layer_size = 87

        self.linear1 = nn.Linear(self.input_layer_size, 80)
        self.linear1_2 = nn.Linear(80, 80)
        self.linear2 = nn.Linear(80, 50)
        self.linear2_2 = nn.Linear(50, 50)
        self.linear3 = nn.Linear(50, 30)
        self.linear4 = nn.Linear(30, 4)

        self.conv1 = make_conv_layer(self.input_layer_size, self.input_layer_size)
        self.conv2 = make_conv_layer(self.input_layer_size, self.input_layer_size)

        self.conv3 = make_conv_layer(60, 30)

        self.dropout1 = nn.Dropout2d(0.0)

        self.batch_norm1 = BatchNorm1d(self.input_layer_size, eps=1e-5, momentum=0.9)
        self.batch_norm2 = BatchNorm1d(self.input_layer_size, eps=1e-5, momentum=0.9)
        self.batch_norm3 = BatchNorm1d(80, eps=1e-5, momentum=0.9)
        self.batch_norm4 = BatchNorm1d(50, eps=1e-5, momentum=0.9)
        self.batch_norm5 = BatchNorm1d(30, eps=1e-5, momentum=0.9)
       
    def forward(self, data, test=False):
        x, edge_index = data.x, data.edge_index
        msg = x
       # edge_index = edge_index[0]
        #print(edge_index.size())
        #edge_index = edge_index[0]
        batch_size = 24
        if test:
            batch_size = 1
       
        hidden = self.init_hidden(batch_size)

        x = self.conv1(x, edge_index)
        #x = self.msg_norm1(x, msg)
        #x = self.graph_norm1(x)
        x = self.batch_norm1(x)
        x = F.relu(x)
        x = self.dropout1(x)
        #x = F.dropout(x, training=self.training)
        #print(x.size())
        #print(hidden.size())
        x = self.conv2(x, edge_index)
        #x = self.msg_norm1(x, msg)
        #x = self.graph_norm1(x)
        x = self.batch_norm2(x)
        x = F.relu(x)
        x = self.dropout1(x)


        
    
  
        
        x = self.linear1(x)
        x = self.batch_norm3(x)
        x = F.relu(x)
        x = self.dropout1(x)

        

        x = self.linear2(x)
        x = self.batch_norm4(x)
        x = F.relu(x)
        x = self.dropout1(x)

       

        x = self.linear3(x)
        
        x = self.batch_norm5(x)
        x = F.relu(x)
      

        x = self.linear4(x)
        


        
        return F.log_softmax(x, dim=1)

    def init_hidden(self, batch_size):
        hidden = torch.zeros(self.num_layers, 1, self.hidden_size)
        device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')
        return hidden.to(device)


class DGC_2(torch.nn.Module):
    def __init__(self):
        super().__init__()
        


        self.linear1 = nn.Linear(87, 40)
        self.linear1_2 = nn.Linear(40,87)
        self.linear2 = nn.Linear(87, 50)
        self.linear3 = nn.Linear(50, 25)
        self.batch_norm3_1 = BatchNorm(25, eps=1e-5, momentum=0.9)
        self.linear3_2 = nn.Linear(25, 50)
        self.batch_norm3_2 = BatchNorm(50, eps=1e-5, momentum=0.9)
        self.linear4 = nn.Linear(50, 23)
        self.linear5 = nn.Linear(23, 17)

        self.conv1 = make_conv_layer(87, 87)
        self.batch_norm1 = BatchNorm(87, eps=1e-5, momentum=0.9)
        self.conv2 = make_conv_layer(87, 87)
        self.batch_norm2 = BatchNorm(87, eps=1e-5, momentum=0.9)
        self.conv3 = make_conv_layer(87, 87)
        self.batch_norm3 = BatchNorm(87, eps=1e-5, momentum=0.9)
        self.conv4 = make_conv_layer(87, 87)
        
        self.msg_norm1 = MessageNorm()

        
        
        self.batch_norm3 = BatchNorm(87, eps=1e-5, momentum=0.9)
        self.batch_norm4 = BatchNorm(87, eps=1e-5, momentum=0.9)
        self.batch_norm6 = BatchNorm(40, eps=1e-5, momentum=0.9)
        self.batch_norm5 = BatchNorm(50, eps=1e-5, momentum=0.9)
    
    def forward(self, data):
        x, edge_index = data.x, data.edge_index
        
        x = self.conv1(x, edge_index)
        msg = x
        x = self.batch_norm1(x)
        x = F.relu(x)
        #x = F.dropout(x, training=self.training)
        
        x = self.conv2(x, edge_index)
        #x = self.msg_norm1(x, msg)
        x = self.batch_norm2(x)
        x = F.relu(x)
        
        x = self.conv3(x, edge_index)
        #x = self.msg_norm1(x, msg)
        x = self.batch_norm3(x)
        x = F.relu(x)

        #x = self.conv4(x, edge_index)
        #x = self.msg_norm1(x, msg)
        #x = self.batch_norm4(x)
        #x = F.relu(x)
        ###########################################

        ###########################################
        msg = x
        ###
        x = self.linear1(x)
        x = self.batch_norm6(x)
        x = F.relu(x)
        x = self.linear1_2(x)
        x = self.batch_norm4(x)
        ####
        x += msg
        x = F.relu(x)

        x = self.linear2(x)
        x = self.batch_norm5(x)
        x = F.relu(x)

        msg = x
        ####
        x = self.linear3(x)
        x = self.batch_norm3_1(x)
        x = F.relu(x)
        x = self.linear3_2(x)
        x = self.batch_norm3_2(x)
        ###

        x += msg
        x = F.relu(x)

        x = self.linear4(x)
        x = F.relu(x)

        x = self.linear5(x)

        
        return F.log_softmax(x, dim=1)